#ifndef _PACKET_H
#define _PACKET_H

#include <QtGlobal> 
#include <QtEndian>

/**Incomming traffic history decoding union.*/
union TtrafficHistory {
	quint8 val;
	struct {
    quint8 evType : 4;/**<Event Type.*/
    bool txErr : 1; /**<Transmit error on outbound UDP packet.*/
	bool rsvd : 1;/**<reserved.*/
    bool rxDrop : 1; /**<Dropped on receipt or requested packet not available.*/
    bool crcFail :1;/**<Failed CRC.*/
	}bit ;
};

struct TstatusPacket {
	quint32 header; /**< Raw header as received*/
	quint32 MTU; /**<MTU in bytes.*/
	quint32 nResponseBuffers; /**<Max overlap supported.*/
	quint32 nextExpectedHeader;
	TtrafficHistory trafficHistory[16]; /**< From oldest (0) to newes (15).*/
	quint32 receivedHeaderHist[4]; /**<Oldest received control packet header (0) to newest (15).*/
	quint32 outgoingHeaderHist[4]; /**<Oldest outgoing control packet header (0) to newest (15).*/
	};
#endif

