-- clock_div_v6
--
-- Dave Newbold, March 2013. Rewritten by Paschalis Vichoudis, June 2013
--
-- $Id$

library ieee;
use ieee.std_logic_1164.all;
--use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;

library unisim;
use unisim.VComponents.all;

entity clock_div is
generic (fast_sim : boolean :=false);
	port(
		clk: in std_logic;
		d17: out std_logic;
		d25: out std_logic;
		d28: out std_logic
	);

end clock_div;

architecture rtl of clock_div is

signal rst_b: std_logic;
signal cnt : std_logic_vector(27 downto 0);

begin

	reset_gen : component srl16
   port map 
	(				
		 a0 	=> '1'  ,
		 a1 	=> '1'  ,
		 a2 	=> '1'  ,
		 a3 	=> '1'  ,
		 clk 	=> clk  ,
		 d 	=> '1'  ,
		 q 	=> rst_b
	);	


	process(rst_b, clk)
	begin
	if rst_b = '0' then
			d28 <= '0';
			d25 <= '0';
			d17 <= '0';
			cnt<=(others => '0');
	elsif rising_edge(clk) then
		if (fast_sim) then
			d28 <= cnt(27-12);
			d25 <= cnt(24-12);
			d17 <= cnt(16-12);
		else
			d28 <= cnt(27);
			d25 <= cnt(24);
			d17 <= cnt(16);
		end if;
		cnt<=cnt+1;
	end if;
	end process;

end rtl;
